// #############################################################################
// # qdmx.c - DMX replacement for the original sound2light controller in       #
// #          "Quark Roller" light effect                                      #
// #############################################################################
// # Version: 1.0 - Compiler: AVR-GCC 4.3.3 (Linux)                            #
// #  (c) 2009 by Malte Pöggel - www.MALTEPOEGGEL.de - malte@maltepoeggel.de   #
// #############################################################################
// #  This program is free software; you can redistribute it and/or modify it  #
// #   under the terms of the GNU General Public License as published by the   #
// #        Free Software Foundation; either version 3 of the License,         #
// #                  or (at your option) any later version.                   #
// #                                                                           #
// #      This program is distributed in the hope that it will be useful,      #
// #      but WITHOUT ANY WARRANTY; without even the implied warranty of       #
// #           MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.            #
// #           See the GNU General Public License for more details.            #
// #                                                                           #
// #  You should have received a copy of the GNU General Public License along  #
// #      with this program; if not, see <http://www.gnu.org/licenses/>.       #
// #############################################################################

#include "qdmx.h"
#include "libs/lib_dmx_in.h"
#include "libs/lib_motdriver.h"
#include "libs/lib_goborotate.h"

int main( void )
 {
  uint8_t  gobo = 0;
  uint32_t lamptimeout = 0;

  cli();

  DDR_LED1 |= (1<<PIN_LED1);			// LED 1
  DDR_LED2 |= (1<<PIN_LED2);			// LED 2
  DDR_LAMP |= (1<<PIN_LAMP);			// LAMP_ON

  PRT_LED1 &= ~(1<<PIN_LED1);
  PRT_LED2 &= ~(1<<PIN_LED2);
  PRT_LAMP &= ~(1<<PIN_LAMP);

  Init_Motor();
  Init_Gobo();
  init_DMX_RX();

  DmxRxField[0]=0;
  DmxRxField[1]=0;
  DmxRxField[2]=127;
  DmxRxField[3]=127;
 
  sei();

  get_dips();					//get start address

  DDR_LED1 |= (1<<PIN_LED1);

  for(;;)
   {
    CheckGobo();

    gobo = (DmxRxField[1]/16);
    if(gobo==15) 
     {
      if(lamptimeout!=0) 
       { 
        lamptimeout--;
       } 
     } else {
      lamptimeout=LAMP_TIMEOUT;
     } 

    // CH1: Lamp & Shutter
    if (DmxRxField[0] >= 128 && lamptimeout!=0)
     {
      DDR_LAMP |= (1<<PIN_LAMP);
     } else {
      DDR_LAMP &= ~(1<<PIN_LAMP);
     }

    // CH2: Gobo wheel
    SetGobo(gobo);

    // CH3: Motor 1
    if (DmxRxField[2] > 132)
     {
      Motor1direction(1);
      PwmVal[0] = (DmxRxField[2]-128)*2;
     } else
       if (DmxRxField[2] > 122)
        {
         PwmVal[0]=255;
         Motor1direction(2);
        } else
          {
           Motor1direction(0);
           PwmVal[0] = (127-DmxRxField[2])*2;
          }

    //CH4: Motor 2
    if (DmxRxField[3] > 132)
     {
      Motor2direction(1);
      PwmVal[1] = (DmxRxField[3]-128)*2;
     } else
       if (DmxRxField[3] > 122)
        {
         PwmVal[1]=255;
         Motor2direction(2);
        } else
          {
           Motor2direction(0);
           PwmVal[1] = (127-DmxRxField[3])*2;
          }

   }
}
